//
// Copyright (C) 1999-2006 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef FBCONFIG_H
#define FBCONFIG_H

//------------------------------------------------------------------
//special display control flags,
//Definition of both of ROTATE90 and DOUBLE_SCALE is not effective.
//------------------------------------------------------------------
//#define ROTATE90
//#define DOUBLE_SCALE
//#define NO_THREAD

//#define DEFAULT_DEVICE_WIDTH   240
//#define DEFAULT_DEVICE_HEIGHT  320
#define DEFAULT_DEVICE_WIDTH   480
#define DEFAULT_DEVICE_HEIGHT  640

#define DEFAULT_DEVICE_DEPTH    32
#define DEFAULT_DEVICE_RED_SHIFT   16
#define DEFAULT_DEVICE_GREEN_SHIFT  8
#define DEFAULT_DEVICE_BLUE_SHIFT   0
#define DEFAULT_DEVICE_RED_BIT    8
#define DEFAULT_DEVICE_GREEN_BIT  8
#define DEFAULT_DEVICE_BLUE_BIT   8

#ifdef ZAURUS

#undef DEFAULT_DEVICE_WIDTH
#undef DEFAULT_DEVICE_HEIGHT
#undef DEFAULT_DEVICE_DEPTH
#undef DEFAULT_DEVICE_RED_SHIFT
#undef DEFAULT_DEVICE_GREEN_SHIFT
#undef DEFAULT_DEVICE_BLUE_SHIFT
#undef DEFAULT_DEVICE_RED_BIT
#undef DEFAULT_DEVICE_GREEN_BIT
#undef DEFAULT_DEVICE_BLUE_BIT

#define DEFAULT_DEVICE_WIDTH   480
#define DEFAULT_DEVICE_HEIGHT  640

#define DEFAULT_DEVICE_DEPTH    16
#define DEFAULT_DEVICE_RED_SHIFT   11
#define DEFAULT_DEVICE_GREEN_SHIFT  5
#define DEFAULT_DEVICE_BLUE_SHIFT   0
#define DEFAULT_DEVICE_RED_BIT    5
#define DEFAULT_DEVICE_GREEN_BIT  6
#define DEFAULT_DEVICE_BLUE_BIT   5

#endif

#ifdef MacOS
#undef DEFAULT_DEVICE_WIDTH
#undef DEFAULT_DEVICE_HEIGHT
#undef DEFAULT_DEVICE_DEPTH
#undef DEFAULT_DEVICE_RED_SHIFT
#undef DEFAULT_DEVICE_GREEN_SHIFT
#undef DEFAULT_DEVICE_BLUE_SHIFT
#undef DEFAULT_DEVICE_RED_BIT
#undef DEFAULT_DEVICE_GREEN_BIT
#undef DEFAULT_DEVICE_BLUE_BIT

#define DEFAULT_DEVICE_WIDTH   480
#define DEFAULT_DEVICE_HEIGHT  640

#define DEFAULT_DEVICE_DEPTH    32
#define DEFAULT_DEVICE_RED_SHIFT   16
#define DEFAULT_DEVICE_GREEN_SHIFT  8
#define DEFAULT_DEVICE_BLUE_SHIFT   0
#define DEFAULT_DEVICE_RED_BIT    8
#define DEFAULT_DEVICE_GREEN_BIT  8
#define DEFAULT_DEVICE_BLUE_BIT   8


#endif

#define DEFAULT_LINUX_FRAME_BUFFER_DEVICE   "/dev/fb0"
#define DEFAULT_LINUX_KEYB_DEVICE   "/dev/input/event0"
#define DEFAULT_LINUX_MOUSE_DEVICE  "/dev/input/event1"

#define TOUCH_PANEL_X_OFFSET    280
#define TOUCH_PANEL_Y_OFFSET    210
#define TOUCH_PANEL_WIDTH       3820
#define TOUCH_PANEL_HEIGHT      3800

#ifdef TE
#define DEFAULT_FONT_DEFINITION  "/SYS/wsfonts"
#elif defined(MacOS)
#define DEFAULT_FONT_DEFINITION  "/usr/local/ws/sys/fonts/wsfonts"
#else
#define DEFAULT_FONT_DEFINITION  "/etc/wsfonts"
#endif

#define MAX_MESSAGES 128

//#define TIME_TRACE(str) printf("%s: %s:%d t=%d\n",str,__FILE__,__LINE__,WSGFdiffTimePoint());WSGFsetTimePoint();
#define TIME_TRACE(str) 
//#define TIME_TRACE2(str) printf("%s: %s:%d t=%d\n",str,__FILE__,__LINE__,WSGFdiffTimePoint());WSGFsetTimePoint();
#define TIME_TRACE2(str) 


#endif

